﻿using System;
using System.ComponentModel;
using System.Data;
using System.Configuration;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;

namespace WebApplication3
{
	public delegate CancelEventHandler BeforeEventHandler(object sender, CancelEventArgs e);
	public delegate EventHandler AfterEventHandler(object sender, EventHandler e);

	public class Sample
	{
		private object EVENT_BEFORE_EVENT	= null;	// Before 이벤트 키 객체
		private object EVENT_AFTER_EVENT	= null;	// After 이벤트 키 객체

		// 이벤트의 수가 많아 질 경우, 대부분의 이벤트가 사용되지 않을 것이라고 예상될 경우 유용한 방법이다.
		// 다음 회차에 좀 더 자세히 알아보자.
		public event CancelEventHandler BeforeEvent
		{
			add
			{
				EVENT_BEFORE_EVENT	= (CancelEventHandler)EVENT_BEFORE_EVENT + value;
			}
			remove
			{
				EVENT_BEFORE_EVENT	= (CancelEventHandler)EVENT_BEFORE_EVENT - value;
			}
		}

		public event EventHandler AfterEvent
		{
			add
			{
				EVENT_AFTER_EVENT	= (EventHandler)EVENT_AFTER_EVENT + value;
			}
			remove
			{
				EVENT_AFTER_EVENT	= (EventHandler)EVENT_AFTER_EVENT - value;
			}
		}

		// Before 이벤트를 발생한다. private 메서드에 주의
		private void OnBefore(object sender, CancelEventArgs e)
		{
			CancelEventHandler handler = (CancelEventHandler)EVENT_BEFORE_EVENT;

			if( handler != null )
				handler(sender, e);
		}

		// After 이벤트를 발생한다. private 메서드에 주의
		private void OnAfter(object sender, EventArgs e)
		{
			EventHandler handler		= (EventHandler)EVENT_AFTER_EVENT;

			if( handler != null )
				handler( sender, e);
		}

		// Before, After 이벤트를 발생하여 Before 이벤트의 Cancel 여부를 판단한다.
		public void OnFire(object sender)
		{
			CancelEventArgs args		= new CancelEventArgs();
			this.OnBefore(sender, args);

			if( args.Cancel ) return;

			this.OnAfter(sender, EventArgs.Empty);
		}
	}
}
